#include <async.h>
#include <arpc.h>
#include "fadd.h"

void connected(str var, int inc, int fd);
void replycb(ptr<aclnt> c, ref<fadd_res> resp, clnt_stat stat);

int
main(int ac, char **av)
{
    if (ac != 4)
	fatal << "Usage: " << av[0] << " port var inc\n";

    str var(av[2]);
    int inc = atoi(av[3]);
    tcpconnect("localhost", atoi(av[1]), wrap(&connected, var, inc));
    amain();
}

void
connected(str var, int inc, int fd)
{
    if (fd < 0)
	fatal << "could not connect\n";

    ptr<axprt> x = axprt_stream::alloc(fd);
    ptr<aclnt> c = aclnt::alloc(x, fadd_prog_1);

    fadd_arg arg;
    arg.var = var;
    arg.inc = inc;

    /* Pre-allocate memory for the server's response */
    ref<fadd_res> resp = New refcounted<fadd_res>();
    c->call(FADDPROC_FADD, &arg, resp, wrap(&replycb, c, resp));
}

void
replycb(ptr<aclnt> c, ref<fadd_res> resp, clnt_stat stat)
{
    if (stat)
	fatal << "rpc error: " << stat << "\n";

    if (!resp->ok)
	fatal << "non-existent variable\n";

    warn << "sum is " << *resp->sum << "\n";
    exit(0);
}
